.TH XvPortNotify 3X 
.\" $XFree86: xc/doc/man/Xv/XvPortNotify.man,v 1.4 1999/03/02 11:49:15 dawes Exp $
.SH Name
XvPortNotify \- event generated when port attributes change
.\"
.SH Syntax
.B #include <X11/extensions/Xvlib.h>
.br
.sp 1l
.EX

     typedef union {
       int type;
       XvVideoNotifyEvent xvvideo;
       XvPortNotifyEvent xvport;
       long pad[24];
     } XvEvent;

     typedef struct {
       int type;
       unsigned long serial;
       Bool send_event;
       Display *display;
       XvPortID port_id;
       Time time;
       Atom attribute;
       long value;
     } XvPortNotifyEvent;

.EE
.\"
.IP \fItype\fR 8
Specifies the type of event: XvPortNotify.
.IP \fIserial\fR 8
Number of the last request processed by the server.
.IP \fIsend_event\fR 8
True if the event was generated by a SendEvent request.
.IP \fIdisplay\fR 8
A pointer to the display the event was read from.
.IP \fIport_id\fR 8
The port whose attribute has changed.
.IP \fIattribute\fR 8
An atom specifying the attribute that changed.
.IP \fIvalue\fR 8
The new value of the attribute.
.\"
.SH Description
.\"
XvPortNotify events are generated when a port attribute is set using
the XvSetPortAttribute(3X) function.
.\"
.SH See Also
XvSetPortAttribute(3X), XvGetPortAttribute(3X), XvSelectPortNotify(3X)
.\"




