/* $XFree86: xc/programs/Xserver/hw/xfree86/ddc/xf86DDC.h,v 1.5 1999/12/03 19:17:26 eich Exp $ */

/* xf86DDC.h
 *
 * This file contains all information to interpret a standard EDIC block 
 * transmitted by a display device via DDC (Display Data Channel). So far 
 * there is no information to deal with optional EDID blocks.  
 * DDC is a Trademark of VESA (Video Electronics Standard Association).
 *
 * Copyright 1998 by Egbert Eich <Egbert.Eich@Physik.TU-Darmstadt.DE>
 */


#ifndef XF86_DDC_H
# define XF86_DDC_H

#include "edid.h"
#include "xf86i2c.h"

/* speed up / slow down */
typedef enum {
  DDC_SLOW,
  DDC_FAST
} xf86ddcSpeed;

extern xf86MonPtr xf86DoEDID_DDC1(
    int scrnIndex, 
    void (*DDC1SetSpeed)(ScrnInfoPtr, xf86ddcSpeed),
    unsigned int (*DDC1Read)(ScrnInfoPtr)
);

extern xf86MonPtr xf86DoEDID_DDC2(
   int scrnIndex,
   I2CBusPtr pBus
);

extern xf86MonPtr xf86PrintEDID(
    xf86MonPtr 
);

extern xf86MonPtr xf86InterpretEDID(
    Uchar *block
);

extern xf86vdifPtr xf86InterpretVdif(
    CARD8 *c
);

extern Bool xf86SetDDCproperties(
     ScrnInfoPtr pScreen,
     xf86MonPtr DDC
);

#endif


