/* $TOG: lbxtags.h /main/8 1998/02/09 14:33:05 kaleb $ */
/*

Copyright 1996, 1998  The Open Group

All Rights Reserved.

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
OPEN GROUP BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of The Open Group shall not be
used in advertising or otherwise to promote the sale, use or other dealings
in this Software without prior written authorization from The Open Group.

*/
/*
 * Copyright 1993 Network Computing Devices, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name Network Computing Devices, Inc. not be
 * used in advertising or publicity pertaining to distribution of this
 * software without specific, written prior permission.
 *
 * THIS SOFTWARE IS PROVIDED `AS-IS'.  NETWORK COMPUTING DEVICES, INC.,
 * DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING WITHOUT
 * LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NONINFRINGEMENT.  IN NO EVENT SHALL NETWORK
 * COMPUTING DEVICES, INC., BE LIABLE FOR ANY DAMAGES WHATSOEVER, INCLUDING
 * SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES, INCLUDING LOSS OF USE, DATA,
 * OR PROFITS, EVEN IF ADVISED OF THE POSSIBILITY THEREOF, AND REGARDLESS OF
 * WHETHER IN AN ACTION IN CONTRACT, TORT OR NEGLIGENCE, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef _LBXTAGS_H_
#define _LBXTAGS_H_
#include	"lbxserve.h"

#include	"os.h"
#include	"opaque.h"
#include	"resource.h"
#include	"X.h"
#include	"Xproto.h"

typedef struct _tagdata {
    XID         tid;
    short       data_type;
    unsigned char sent_to_proxy[(MAX_NUM_PROXIES + 7) / 8];
    int		size;
    pointer     tdata;
    XID		*global;
}           TagDataRec;

typedef struct _tagdata *TagData;

extern TagData TagGetTag(
#if NeedFunctionPrototypes
    XID         /*tid*/
#endif
);

extern XID  TagNewTag(
#if NeedFunctionPrototypes
    void
#endif
);

extern void TagClearProxy(
#if NeedFunctionPrototypes
    XID         /*tid*/,
    int         /*pid*/
#endif
);

extern void TagMarkProxy(
#if NeedFunctionPrototypes
    XID         /*tid*/,
    int         /*pid*/
#endif
);

extern Bool TagProxyMarked(
#if NeedFunctionPrototypes
    XID         /*tid*/,
    int         /*pid*/
#endif
);

extern void TagDeleteTag(
#if NeedFunctionPrototypes
    XID         /*tid*/
#endif
);

extern XID TagSaveTag(
#if NeedFunctionPrototypes
    int         /*dtype*/,
    int         /*size*/,
    pointer     /*data*/,
    XID*        /*global*/
#endif
);

#endif				/* _LBXTAGS_H_ */
